#include "v.h"

#include <Wt/WContainerWidget.h>
#include <Wt/WPushButton.h>
#include <Wt/WVBoxLayout.h>
#include <Wt/WSelectionBox.h>
#include <Wt/WCheckBox.h>
#include <Wt/WGridLayout.h>
#include "Popup.h"

using namespace std;

V::V(const WEnvironment &env)
: WApplication(env)
{
    
}

V::~V()
{
}

void V::Create()
{
    
    WContainerWidget * C = root()->addWidget(std::make_unique<WContainerWidget> ());
    WVBoxLayout * vbl = new WVBoxLayout();
    C->setLayout(unique_ptr<WVBoxLayout> (vbl));
    vbl->addWidget(std::make_unique<WSelectionBox> ())->setAttributeValue("dir", "auto");
    vbl->addWidget(std::make_unique<WCheckBox> ("CheckBox"));
    WGridLayout * glButtons = new WGridLayout;
    WPushButton * m_btnA = glButtons->addWidget(make_unique<WPushButton>("A (active)"), 0, 0);
    glButtons->addWidget(make_unique<WPushButton>("B"), 0, 1);
    glButtons->addWidget(make_unique<WPushButton>("C"), 1, 0);
    glButtons->addWidget(make_unique<WPushButton>("D"), 1, 1);
    vbl->addLayout(unique_ptr<WGridLayout> (glButtons));
    
    m_btnA->clicked().connect(this, &V::ShowPopup);
}

void V::ShowPopup()
{
    Popup * p = new Popup(); // Not being deleted in this showcase.
    p->Create();
    p->UpdateAnchorWidget(m_btnA);
    p->show();
}
